package OrderToPay;

import com.metamaxim.modelscope.callbacks.*;
import java.text.DecimalFormat;

public class Dashboard extends Behaviour {


	public int getClosedOrderCount() {
		
		int closedOrderCount = 0;
		Instance[] closedorders = selectInState("Order", "Closed");
		for (int i = 0; i < closedorders.length; i++) 
			closedOrderCount += 1;
		return closedOrderCount;
	}

	public int getAverageProcessingLeadTime() {

		int totalProcessingLeadTime = 0;
		int averageProcessingLeadTime = 0;
		Instance[] closedorders = selectInState("Order", "Closed");
		for (int i = 0; i < closedorders.length; i++) 
			totalProcessingLeadTime += closedorders[i].getInteger("Processing Lead Time");			
		
		int closedOrderCount = this.getInteger("Closed Order Count");	
		if (closedOrderCount > 0) 
			averageProcessingLeadTime = totalProcessingLeadTime / closedOrderCount;
		return averageProcessingLeadTime;
	}

	public int getKeyPerformanceIndicator() {

		int normLeadTime = this.getInteger("Norm Lead Time");
		int inTime = 0;
		int tooLate = 0;

		Instance[] closedorders = selectInState("Order", "Closed");
		for (int i = 0; i < closedorders.length; i++) {
			int processingLeadTime = closedorders[i].getInteger("Processing Lead Time");
			if (processingLeadTime > normLeadTime)  
				tooLate += 1;
			else 	inTime += 1;
		}

		int closedOrderCount = inTime + tooLate;
		int KeyPerformanceIndicator = (int)((inTime * 100.0f) / closedOrderCount);
		return KeyPerformanceIndicator;		
	}
public void processCreateDashboard(Event event, String subscript)  {
		
		event.log();
	}	
public void processChangeNorm(Event event, String subscript)  {
		
		event.log();
	}

}

